function [Field,FX,FY]=Volume_density_setup_2D(kernel,k,N)
    x=linspace(-2,2,4*N+1);
    x=x(1:end-1);
%    find(x==0);
%    y=x;
%    z=x;
    dx=x(2)-x(1);
%    dy=y(2)-y(1);
%    dz=z(2)-z(1);
%    [X,Y,Z]=meshgrid(x,y,z);
%    rho_zeros=zeros(4*N,4*N,4*N);
%    rho_zeros(2*N+1:3*N,2*N+1:3*N,2*N+1:3*N)=rho;
%    rho_zeros(2*N+1,2*N+1,2*N+1)=1;
    R_max=1.8;

%    FT_source=mi_fftn(rho_zeros,dx);
%    FT_source(1:10)
%    pause
    [GG]=FFTNGREEN_setup(kernel,k,dx,4*N+1,R_max);
    
%    Field=mi_ifftn(GG.*FT_source,dx);
%    Field=Field(2*N+1:3*N,2*N+1:3*N,2*N+1:3*N);
%%%%    Field=mi_ifftn(FT_source.*GG,dx);

    Field=mi_ifftn(GG,dx);

    %    Field=Field(2*N+1:3*N,2*N+1:3*N,2*N+1:3*N);    
    Field=Field(N+1:3*N,N+1:3*N)*N^2;
    Field=mi_fftn(Field,dx).*dx^2;
    Field=fftshift(Field);   %Mucho ojo con esto
    
    [FX,FY]=FFTNGREEN_indexes(k,dx,2*N+1,R_max);

    
end

function F=mi_fftn(y,dx)
    F=fftshift(fftn(ifftshift(y)))*dx^2;
end

function F=mi_ifftn(y,dx)
    F=fftshift(ifftn(ifftshift(y)))/(dx^2);
end



function [FX,FY]=FFTNGREEN_indexes(k,dx,N,R_max)
    df=1/dx/(N-1);
    indices=(-(N-1)/2:1:(N-1)/2-1);
    fx=indices*df;
    fy=fx;
    [FX,FY]=meshgrid(fx,fy);
    FX=fftshift(FX);
    FY=fftshift(FY);
    
%    S=2*pi*sqrt(FX.^2+FY.^2+FZ.^2);
%    GG=(-1+exp(i*k*R_max).*(cos(R_max*S)-i*k*R_max*sinc(R_max*S/pi)))./((k-S).*(k+S));
%    indices=find(S==0);
%    GG(indices)=(-1+exp(i*k*R_max).*(1-i*k*R_max))./(k^2);

end


function [GG]=FFTNGREEN_setup(kernel,k,dx,N,R_max)
    df=1/dx/(N-1);
    indices=(-(N-1)/2:1:(N-1)/2-1);
    fx=indices*df;
    fy=fx;
    [FX,FY]=meshgrid(fx,fy);
    S=2*pi*sqrt(FX.^2+FY.^2);

%     S=2*pi*sqrt(FX.^2+permute(FX,[2,1,3]).^2+permute(FX,[3,1,2]).^2);
%    GG=(-1+exp(i*k*R_max).*(cos(R_max*S)-i*k*R_max*sinc(R_max*S/pi)))./((k-S).*(k+S));
%    indices=find(S==0);
%    GG(indices)=(-1+exp(i*k*R_max).*(1-i*k*R_max))./(k^2);

    if strcmp(kernel,'Helmholtz')
% %        GG=mi_espectro(S,k,R_max);
%         GG=(1+i*pi/2*R_max*(S.*besselj(1,S*R_max).*besselh(0,k*R_max)-k*besselj(0,S*R_max).*besselh(1,k*R_max)))./(S.^2-k^2);        
%         indice_singular=find(S==k); 
%         indice_singular=find(abs(S-k)<1e-13); 
% %        diferences=abs(S-k);
% %        min(diferences(:))
% %        pause
%         GG(indice_singular)=i*pi*R_max*((2*besselj(1,k*R_max)-k*R_max*besselj(2,k*R_max))*besselh(0,k*R_max)+ k*R_max*besselj(1,k*R_max)*besselh(1,k*R_max))/(4*k);    
% %        indices=find(isnan(GG))
% %        pause
% 
% %    find(isnan(GG))
% %    delta_S=S-k;
% %    min(min(S))
% %    min(min(abs(delta_S)*R_max))



    deltaS=S-k;
    indices_near=find(abs(deltaS)<0.6);
    indices_far=find(abs(deltaS)>=0.6);
    GG=zeros(size(S));
    GG(indices_far)=(1+i*pi/2*R_max*(S(indices_far).*besselj(1,S(indices_far)*R_max).*besselh(0,k*R_max)-k*besselj(0,S(indices_far)*R_max).*besselh(1,k*R_max)))./(S(indices_far).^2-k^2);        
    GG1=i*pi*R_max/2*besselj(1,R_max*S(indices_near)).*besselh(0,R_max*k)./(2*k+deltaS(indices_near));
    GG2=(-bessel_minus_one(R_max*deltaS(indices_near)))./(S(indices_near).^2-k^2);
    Suma=0; 
    N=30;
    for count=-N:N
        if count==0
         else
             Suma=Suma+(besselj(1-count,R_max.*k).*besselh(0,k*R_max)-besselj(-count,R_max*k).*besselh(1,R_max*k)).*besselj(count,R_max*deltaS(indices_near));
         end
     end
% 
%     
     GG3=i*pi*R_max*k./(2*(2*k+deltaS(indices_near)).*deltaS(indices_near)).*Suma;
     GG(indices_near)=GG1+GG2+GG3;
     indice_singular=find(S==k); 
     GG(indice_singular)=i*pi*R_max*((2*besselj(1,k*R_max)-k*R_max*besselj(2,k*R_max))*besselh(0,k*R_max)+ k*R_max*besselj(1,k*R_max)*besselh(1,k*R_max))/(4*k);    

    elseif strcmp(kernel,'Laplace')
        GG=- (bessel_minus_one(R_max*S))./S.^2 - (R_max*log(R_max)*besselj(1, R_max*S))./S;
%       GG=-((besselj(0, R_max*S) - 1)./S.^2 + (R_max*log(R_max).*besselj(1, R_max*S))./S);
        indices=find(S==0);
        GG(indices)=R_max^2/4*(1-2*log(R_max));
    elseif strcmp(kernel,'Biharmonic')
%        GG=(besselj(0, R_max*S) - 1)./S.^4 - (R_max^3*(log(R_max) - 1)*besselj(1, R_max*S))./(4*S) + (R_max*log(R_max)*besselj(1, R_max*S))./S.^3 - (R_max^2*(2*log(R_max) - 1)*besselj(0, R_max*S))./(4*S.^2);
        GG=(bessel_minus_one(R_max*S))./S.^4 - (R_max^3*(log(R_max) - 1)*besselj(1, R_max*S))./(4*S) + (R_max*log(R_max)*besselj(1, R_max*S))./S.^3 - (R_max^2*(2*log(R_max) - 1)*besselj(0, R_max*S))./(4*S.^2);
        indices=find(S==0);
        GG(indices)=R_max^4/64*(5-4*log(R_max));   
    end
    
end

function y=bessel_minus_one(z)
    umbral=0.3;
    index_near=find(abs(z)<umbral);
    index_far=find(abs(z)>=umbral);
    y=zeros(size(z));
    y(index_far)=besselj(0,z(index_far))-1;
    if length(index_near)>0
        y(index_near)=-2*(besselj(2,z(index_near))+besselj(4,z(index_near))+besselj(6,z(index_near))+besselj(8,z(index_near))+besselj(10,z(index_near))+besselj(12,z(index_near)));
    end
end


