function hCampLen= compPunSigma(NNVar, sigmaVar, diagLog, phiVector, sum, hCampLen)
    lenPun=length(NNVar);
    lenSig=length(sigmaVar); 

    if lenPun==1
        %% Solo un valor de ventana
        legCompSig= cell(zeros(1,lenSig));
        maxDiagTot= lenSig;

        for countcS= 1:lenSig 
            maxDiag= max(diagLog(:,:,countcS));
            maxDiagTot(countcS)= maxDiag;
            legnd1= ['1/\sigma= ' num2str(sigmaVar(countcS))];
            legCompSig(countcS)= cellstr(legnd1); %Array con todas las leyendas

        end
        
        diagLogPlot=permute(diagLog,[3 2 1])';
        sum=sum+1;
        hCampLen(sum)=figure;
        
        plot(phiVector,diagLogPlot)
        
        title(['Diagramas de radiacin para NN= ' num2str(NNVar)])
        legend(legCompSig,'Location','south')
        xlabel('\phi (rad)', 'FontSize',12,'FontWeight','bold')
        xlim([-3.5 3.5])
        ylabel('Directividad (dB)', 'FontSize',12,'FontWeight','bold')
        DmaxAx = gca;
        DmaxAx.FontSize= 12;
        DmaxAx.FontWeight='bold';
        hold off
        
        sum=sum+1;
        hCampLen(sum)= figure;
        
        plot(sigmaVar,maxDiagTot,'-*','LineWidth',0.7)
        title(['Diagramas de radiacin para NN= ' num2str(NNVar)])
        xlabel('1/\sigma','FontSize',12,'FontWeight','bold')
        ylabel('Directividad mxima (dB)','FontSize',12,'FontWeight','bold')
        xlim([min(sigmaVar)-.5 max(sigmaVar)+.5])
        DmaxNNAx = gca;
        DmaxNNAx.FontSize= 12;
        DmaxNNAx.FontWeight='bold';


    elseif lenSig==1
        %% Solo un valor de sigma
        legCompPun= cell(zeros(1,lenPun));
        maxDiagTot= lenPun;
    
        for countcP= 1:lenPun
            maxDiag= max(diagLog(countcP,:,:));
            maxDiagTot(countcP)= maxDiag;
        
            legnd1= ['NN= ' num2str(NNVar(countcP))...
                ' Max= ' num2str(maxDiag)];%Aade leyenda de cada punto
            legCompPun(countcP)= cellstr(legnd1); %Array con todas las leyendas
            hold on

        end
        
        sum=sum+1;
        hCampLen(sum)=figure;
        plot(phiVector,diagLog)
        title(['Diagramas de radiacin para 1/\sigma= ' ...
            num2str(sigmaVar)])
        legend(legCompPun,'Location','south')
        xlabel('\phi (rad)', 'FontSize',12,'FontWeight','bold')
        ylabel('Directividad (dB)', 'FontSize',12,'FontWeight','bold')
        xlim([-3.5 3.5])
        DmaxAx = gca;
        DmaxAx.FontSize= 12;
        DmaxAx.FontWeight='bold';
        hold off
          
        sum=sum+1;
        hCampLen(sum)=figure;
        plot(NNVar,maxDiagTot,'-*','LineWidth',0.7)
        title(['Diagramas de radiacin para 1/\sigma= ' ...
            num2str(sigmaVar)])
        xlabel('NN','FontSize',12,'FontWeight','bold')
        ylabel('Directividad mxima (dB)','FontSize',12,'FontWeight','bold')
        xlim([min(NNVar)-1 max(NNVar)+1])
        DmaxNNAx = gca;
        DmaxNNAx.FontSize= 12;
        DmaxNNAx.FontWeight='bold';
%}    
   
    else
        %% Varios valores de NN y de sigma 
        maxDiagTot= zeros(lenPun,lenSig);

        for countP= 1:lenPun

            legcompPS= cell(zeros(1,lenPun));            
            for countS= 1:lenSig
                maxDiag= max(diagLog(countP,:,countS));
                maxDiagTot(countP,countS)=maxDiag;
                legSig=['1/\sigma= ' num2str(sigmaVar(countS))...
                    ' Max= ' num2str(maxDiag)];
                legcompPS(countS)=cellstr(legSig);
            end
            diagLogPlot=diagLog(countP,:,:);
            diagLogPlot= permute(diagLogPlot,[3 2 1]);
            
            sum= sum+1;
            hCampLen(sum)= figure;
            plot(phiVector,diagLogPlot)
            title(['Diagramas de radiacin para NN= ' num2str(NNVar(countP))])
            hold off
            legend(legcompPS,'Location','south')
            xlabel('\phi (rad)', 'FontSize',12,'FontWeight','bold')
            ylabel('Directividad (dB)', 'FontSize',12,'FontWeight','bold')
            xlim([-3.5 3.5])
            DmaxAx = gca;
            DmaxAx.FontSize= 12;
            DmaxAx.FontWeight='bold';

        end
        
        sum=sum+1;
        hCampLen(sum)=figure;

        plot(NNVar,maxDiagTot','-*','LineWidth',0.7)
        MaxSigNN = gca;
        MaxSigNN.FontSize= 12;
        MaxSigNN.FontWeight='bold';
        xlabel('NN','FontSize',12,'FontWeight','bold')
        ylabel('Directividad mxima (dB)','FontSize',12,'FontWeight','bold')
        xlim([min(NNVar)-1 max(NNVar)+1])
        legend(legcompPS)
        
        f= figure;
        tablaMaximos= uitable(f);
        tablaMaximos.RowName= NNVar;
        tablaMaximos.ColumnName= sigmaVar;
        tablaMaximos.Data= maxDiagTot;
    end

end

