function q=q_2D_limpio(lente,N,k)

    if strcmpi('fgaheterog',lente) || strcmpi('heterog',lente) 
%%% LENTE PLANA HETEROGENEA:
% {
            x0_foco= -.1; %(siempre supondremos que el foco est aqu)
            y0_foco= .5;

            x= linspace(0,1,N+1);
            x= x(1:end-1);
            y= x;
            [X,Y]= meshgrid(x,y);

            p= .8;  %Distancia del foco al inicio de la lente (en horizontal)
            a= .25; %Grosor de la lente
            R= .4;  %radio de la lente (desde el centro al extremos superior)  

            q= ((sqrt(p^2+R^2)+a-sqrt(p^2+(Y-y0_foco).^2))/a).^2-1;
            indices_fuera= find(abs(X-(x0_foco+p+a/2))>(a/2));
            q(indices_fuera)= 0;
            indices_fuera= find(abs(Y-y0_foco)>R);
            q(indices_fuera)= 0;
            
            if strcmpi('heterog', lente)
                inicioLente=find(y==0.7); %En esa posicin se inicia la lente
                figure
                varindice=q(:,inicioLente+1);
                y=1:length(q);
                plot(varindice,y,'LineWidth',0.7)
                legend(['Max= ' num2str(max(varindice))],'Location','south')
                ax = gca;
                ax.FontSize= 12;
                ax.FontWeight= 'bold';
                
                xlabel('Puntos de muestra', 'FontSize',12, ...
                    'FontWeight', 'bold')
                yl=ylabel('$$\varepsilon$$', 'FontSize', 20,...
                    'FontWeight', 'bold');
                yl.Interpreter='latex';
               
            end

%%%FIN LENTE PLANA HETEROGENEA:
%}

%%% LENTE PLANO CONVEXA:
% { 
    elseif strcmpi('placnvex',lente) || strcmpi('fgaplacnvex',lente)
            % Posicin del foco
            x0_foco= -.1; 
            y0_foco= .5;  
            
            % Valores predeterminados
            epsilon= 2;
            R= .375;  %D/2 de la lente
            f= .75;  %Distancia focal
            
            %Matriz de mallado
            x= linspace(0,1,N+1);
            x= x(1:end-1);
            y= x;
            [X,Y]= meshgrid(x,y);
            ep= X*0+epsilon; %Matriz de epsilons
            
            % Bsqueda de valores fuera de la lente
            x_min= x0_foco+f-param(Y-y0_foco,epsilon,R,f);
            indices1= find(X<x_min);
            ep(indices1)= 1; 
            x_max= x0_foco+f;
            indices2= find(X>x_max);
            ep(indices2)= 1;
            q= ep-1;%Normalizacin
%%%FIN LENTE PLANO CONVEXA 
%} 
 
 
%%%%% LENTE PLANO CONVEXA FRESNEL
% {
    elseif strcmpi('fgaplacnvexfres',lente) || strcmpi('placnvexfres',lente)
        
            x0_foco=-.1; % Coordenada x de la fuente
            y0_foco=.5;

            epsilon=2;
            R=.375;  %D/2 de la lente
            f=.75;  %Distancia focal
            x=linspace(0,1,N+1);
            x=x(1:end-1);
            y=x;
            [X,Y]=meshgrid(x,y);
            ep=X*0+epsilon;

            lambda=2*pi/k;
            n=-10:1:10;
            Rn=sqrt(-f^2+(-n*lambda+sqrt(R^2+f^2)).^2);
            
            indices=find((imag(Rn)==0)&real(Rn)>=0&real(Rn)<=R+.00000000000001);
            Rn=sort(Rn(indices),'descend');%, -fliplr(sort(Rn(indices)))]
            %multiplo=sqrt(R^2+f^2)-sqrt(Rn.^2+f^2);
            %lambda

            x_min=x0_foco+f-param2(Y-y0_foco,epsilon,R,f,Rn);
            indices1=find(X<x_min);
            ep(indices1)=1;

            x_max=x0_foco+f;
            indices2=find(X>x_max);
            ep(indices2)=1;
            q=ep-1;
%}  
%%%%%FIN LENTE PLANO CONVEXA FRESNEL
    end
end
 
function x=param2(r,epsilon,R,f,Rn)
    R_vector=zeros(size(r));
    for count=1:length(Rn)
        indices=find(abs(r)<Rn(count));
        R_vector(indices)=Rn(count);
    end
    R=R_vector;
    T=sqrt(R.^2+f^2);
    A=epsilon-1;
    B=2*f-2*T*sqrt(epsilon);
    C=T.^2-f^2-r.^2;
    x=(-B-sqrt(B.^2-4.*A.*C))./(2*A);
 
end
 
function x=param(r,epsilon,R,f)
    T=sqrt(R.^2+f^2);
    A=epsilon-1;
    B=2*f-2*T*sqrt(epsilon);
    C=T.^2-f^2-r.^2;
    x=(-B-sqrt(B.^2-4.*A.*C))./(2*A);
 
end